import { PingbackEventType } from '@giphy/js-types';

type PingbackAttributes = {
    [key: string]: string;
};
type Pingback = {
    userId?: string | number;
    eventType?: PingbackEventType;
    actionType: PingbackActionType;
    attributes?: PingbackAttributes;
    queueEvents?: boolean;
    analyticsResponsePayload: string;
};
type PingbackActionType = 'CLICK' | 'SEEN' | 'HOVER' | 'FAVORITE' | 'SENT' | 'START';
type PingbackEvent = {
    event_type?: PingbackEventType;
    user_id?: string;
    logged_in_user_id?: string;
    action_type: string;
    random_id?: string;
    attributes: any;
    ts: number;
    analytics_response_payload?: string;
};

declare const mergeAttribute: (attributes: PingbackAttributes, newAttributes: PingbackAttributes, key: string) => {
    [x: string]: string;
};

declare const pingback: ({ userId, eventType, actionType, attributes, queueEvents, analyticsResponsePayload, }: Pingback) => void;

export { Pingback, PingbackActionType, PingbackAttributes, PingbackEvent, mergeAttribute as mergeAttributes, pingback };
